Bug 1017401 - Review Request: ghc-primes - Efficient purely functional generation of prime numbers
Review Request: ghc-primes - Efficient purely functional generation of prime ...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jens Petersen
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-09 15:35 EDT by Jochen Schmitt
Modified: 2013-10-24 11:26 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-10-24 11:26:28 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
petersen: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
1-ghc-primes.spec.patch (1.29 KB, patch)
2013-10-17 03:46 EDT, Jens Petersen
no flags Details | Diff

  None (edit)
Description Jochen Schmitt 2013-10-09 15:35:15 EDT
Spec URL: http://www.herr-schmitt.de/pub/ghc-primes/ghc-primes.spec
SRPM URL: http://www.herr-schmitt.der/pub/ghc-primes/ghc-primes-0.2.1.0-1-fc19.src.rpm
Description:
This Haskell library provides an efficient lazy wheel sieve
for prime generation inspired by /Lazy wheel sieves and
spirals of/ /primes/ by Colin Runciman and /The Genuine Sieve
of Eratosthenes/ by Melissa O'Neil.

FAS Name: s4504kr



Fedora Account System Username:
Comment 1 Jens Petersen 2013-10-15 23:29:25 EDT
Is it possible you could clean up the /italics/ from the description?
Maybe just replace '/'s with '"'?

What do you plan to use this library for? :)

http://packdeps.haskellers.com/reverse/primes
Comment 2 Jens Petersen 2013-10-15 23:32:17 EDT
Also if you use https://admin.fedoraproject.org/updates/FEDORA-2013-17948/cabal-rpm-0.8.6-1.fc19 (still updates-testing) you will get a static provides in the devel subpackage which is better.
Comment 4 Jens Petersen 2013-10-17 02:48:27 EDT
I think you forgot to update the SPEC url.

The license is not MIT I think.

I opened this upstream issue
https://github.com/sebfisch/primes/issues/2
since the License file seems to same Public Domain
even though the .cabal file and source file consistently
state BSD 3 Clause license.
Perhaps it would be better to exclude the license
file from the package until this is resolved upstream?
Comment 5 Jens Petersen 2013-10-17 03:46:17 EDT
Created attachment 813218 [details]
1-ghc-primes.spec.patch

I was suggesting something like these changes in my earlier comments
(plus License tag fix).

(cabal-rpm-0.8.6 is still in updates-testing this week.)
Comment 7 Jens Petersen 2013-10-21 03:47:46 EDT
Thanks for the update.

BTW:

%if 0%{?fedora} > 19
rm -f ${RPM_BUILD_ROOT}%{_docdir}/%{name}/LICENSE
%else
rm -f ${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}/LICENSE
%endif

you can use %{_pkgdocdir} for this:

rm ${RPM_BUILD_ROOT}%{_pkgdocdir}/LICENSE

should work across all current Fedora releases
(though not yet for EPEL).
Comment 8 Jens Petersen 2013-10-21 04:38:17 EDT
I recommend quoting the commented %doc in the filelist to avoid
the rpmlint warning about macro in comment.

Otherwise the package looks basically looks fine to me.

(Not sure if it is some local mock issue but fedora-review
gave me some slightly strange outputs so I may wait a day or so
to approve finally in case anyone can clarify.)


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

Issues:
=======
- Static libraries in -static or -devel subpackage, providing -devel if
  present.
  Note: Package has .a files: ghc-primes-devel. Does not provide -static: ghc-
  primes-devel.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#StaticLibraries

I believe this is a fedora-review bug: static is provided,
though see also Haskell Packaging Guidelines which cover this.

===== MUST items =====

C/C++:
[-]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed

False positive?

[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[-]: License field in the package spec file matches the actual license.
     Note: There is no build directory. Running licensecheck on vanilla
     upstream sources. No licenses found. Please check the source files for
     licenses manually.
[-]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib64/ghc-7.6.3/package.conf.d,
     /usr/lib64/ghc-7.6.3
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib64/ghc-7.6.3,
     /usr/lib64/ghc-7.6.3/package.conf.d

@fedora-review: Huh?
Both owned by ghc

[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).

But I suggest using _pkgdocdir as mentioned in previous comment.

[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 122880 bytes in 16 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.

https://github.com/sebfisch/primes/issues/2

[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Bad spec filename: /home/petersen/tmp/1017401-ghc-primes/srpm-
     unpacked/ghc-primes.spec
     See: (this test has no URL)

Dunno what fedora-review is thinking here.

[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.

Rpmlint
-------
Checking: ghc-primes-0.2.1.0-3.fc21.x86_64.rpm
          ghc-primes-devel-0.2.1.0-3.fc21.x86_64.rpm
          ghc-primes-0.2.1.0-3.fc21.src.rpm
ghc-primes.x86_64: W: no-documentation
ghc-primes.src:55: W: macro-in-comment %doc
3 packages and 0 specfiles checked; 0 errors, 2 warnings.

Rpmlint (installed packages)
----------------------------
# rpmlint ghc-primes-devel ghc-primes
2 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'

Requires
--------
ghc-primes-devel (rpmlib, GLIBC filtered):
    /bin/sh
    ghc(primes-0.2.1.0-2818fbc3d9767d52ec3611f9cdbc3353)
    ghc-compiler
    ghc-devel(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    ghc-primes(x86-64)

ghc-primes (rpmlib, GLIBC filtered):
    ghc(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    libHSbase-4.6.0.1-ghc7.6.3.so()(64bit)
    libHSghc-prim-0.3.0.0-ghc7.6.3.so()(64bit)
    libHSinteger-gmp-0.5.0.0-ghc7.6.3.so()(64bit)
    libc.so.6()(64bit)
    libgmp.so.10()(64bit)
    rtld(GNU_HASH)

Provides
--------
ghc-primes-devel:
    ghc-devel(primes-0.2.1.0-2818fbc3d9767d52ec3611f9cdbc3353)
    ghc-primes-devel
    ghc-primes-devel(x86-64)
    ghc-primes-static

ghc-primes:
    ghc(primes-0.2.1.0-2818fbc3d9767d52ec3611f9cdbc3353)
    ghc-primes
    ghc-primes(x86-64)
    libHSprimes-0.2.1.0-ghc7.6.3.so()(64bit)

Unversioned so-files
--------------------
ghc-primes: /usr/lib64/ghc-7.6.3/primes-0.2.1.0/libHSprimes-0.2.1.0-ghc7.6.3.so

Source checksums
----------------
http://hackage.haskell.org/packages/archive/primes/0.2.1.0/primes-0.2.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : 74d66558fb638ea4d31eae2fe1a294cb5a9d64491314305d74a11d93f277c65b
  CHECKSUM(SHA256) upstream package : 74d66558fb638ea4d31eae2fe1a294cb5a9d64491314305d74a11d93f277c65b

Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1017401
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 9 Jens Petersen 2013-10-23 00:00:10 EDT
The package looks standard and fine to me, so I am approving this.

APPROVED
Comment 10 Jens Petersen 2013-10-23 00:01:01 EDT
(Still curious what you want to use this for in Fedora?)
Comment 11 Jochen Schmitt 2013-10-23 15:27:55 EDT
New Package SCM Request
=======================
Package Name: ghc-primes
Short Description: Efficient purely functional generation of prime numbers
Owners: s4504kr
Branches: F-20, F-19
InitialCC: haskell-devel@lists.fedoraproject.org
Comment 12 Gwyn Ciesla 2013-10-23 15:54:29 EDT
WARNING: "haskell-devel@lists.fedoraproject.org" is not a valid FAS account.
Comment 13 Jens Petersen 2013-10-23 20:32:58 EDT
Jochen please use "haskell-sig" for InitialCC, thanks.
Comment 14 Jochen Schmitt 2013-10-24 10:17:50 EDT
New Package SCM Request
=======================
Package Name: ghc-primes
Short Description: Efficient purely functional generation of prime numbers
Owners: s4504kr
Branches: F-20, F-19
InitialCC: haskell-sig
Comment 15 Gwyn Ciesla 2013-10-24 10:27:17 EDT
Git done (by process-git-requests).
Comment 16 Jochen Schmitt 2013-10-24 11:26:28 EDT
Built and pushed for Rawhide, F-20 and F-19

Note You need to log in before you can comment on or make changes to this bug.